% This program will generate data and estimate. 
% Results will be saved for subsequent bootstrap

% It is based on REDO 6 which was used for the first submitted draft

lbl1='Roy_MC2';
nrep=400;
nrep1=1;
nrep2=nrep;

np=1;
ii=1;
mytask=getenv('SLURM_ARRAY_TASK_ID');
ii=str2num(mytask);

nrep1=1+np*(ii-1);
nrep2=np*ii;
 
logfile_name=strcat(lbl1,'generate-Diary.log');
delete(logfile_name);
diary(logfile_name);
diary on
fprintf('Good Morning. I hope it is a beautiful day in Downtown Chicago\n\n');
fprintf('Todays date is: \n'); fprintf(date);
diary off;
should_print=false;

n=2000;
k=8;
bhats=zeros(nrep,k);
shats1=zeros(nrep,k);
shats2=zeros(nrep,k);
shats3=zeros(nrep,k);
fcts=zeros(nrep,1);


for irep=nrep1:nrep2;
    
    diary on;
    fprintf('\n')
    fprintf('\n*************************************************\n')
    fprintf('\nReplication Number: %d\n',irep)
    fprintf('\n*************************************************\n')
    diary off;
    
    tic
    rng(7509+31*irep,'twister');
     
    betaSector1=[1;1];
    
    betaSector2=[0.5;1];
    gammaSector1=0.0;
    gammaSector2=1;
    si1=sqrt(2);
    si2=sqrt(3);
  
    tran=[log(abs(si1));  log(abs(si2))];
    
    
    rho=0.95;

    x1=[ones(n,1) randn(n,1)];
    x2=[ones(n,1) randn(n,1)];
    e11=randn(n,1);
    e21=randn(n,1);
    e12=randn(n,1);
    e22=randn(n,1);

    [wageT1,wageT2,Sector1chosen_T1,Sector1chosen_T2] = ...
    generatedata_from_Roy(betaSector1,gammaSector1,...
    betaSector2,gammaSector2,tran,rho,x1,x2,e11,e21,e12,e22);

    Rrep=2;
    theta_true=[betaSector1; betaSector2; gammaSector1; gammaSector2; tran];
    b_true=theta_true;
    theta_start=theta_true;
    [theta_hat,e_s1t1m,e_s2t1m,e_s1t2m,e_s2t2m,ValphaInverse]=estimate_theta1(x1,x2,wageT1,wageT2,Sector1chosen_T1,Sector1chosen_T2, theta_start,Rrep,rho);
 
    filename=[lbl1 '_data_and_theta' num2str(irep) '.mat']; 
    save(filename, 'theta_true','theta_hat','e_s1t1m','e_s2t1m','e_s1t2m','e_s2t2m','ValphaInverse', 'x1','x2','wageT1','wageT2','Sector1chosen_T1','Sector1chosen_T2', 'theta_start','Rrep','rho');

end



