% Here we calculate the and save the a's. We also calculate the standard
% errors the "old" way

%addpath('..');
lbl1='Roy_MC2';
nrep=400;
nrep1=1;
nrep2=1;

np=1;
ii=1;
mytask=getenv('SLURM_ARRAY_TASK_ID');
ii=str2num(mytask);

nrep1=1+np*(ii-1);
nrep2=np*ii;


k=8;
 
logfile_name=strcat(lbl1,'part2_deltas_and_as_fixed_directions-Diary_2.log');
delete(logfile_name);
diary(logfile_name);
diary on
fprintf('Good Morning. I hope it is a beautiful day in Downtown Chicago\n\n');
fprintf('Todays date is: \n'); fprintf(date);
diary off;
should_print=false;
bhats=zeros(nrep,k);
shats1=zeros(nrep,k);
shats2=zeros(nrep,k);
shats3=zeros(nrep,k);

Results(nrep) = struct('theta_hat',[], 'a_s',[], 'delta_s',[], 'boot_id',[]);




for irep=nrep1:nrep2;
    

        fprintf('\n*************************************************\n')
        fprintf('\n     Replication Number: %d',irep)
        fprintf('\n*************************************************\n')

    rng(751+19219*irep,'twister');
    filename=[lbl1 '_data_and_theta' num2str(irep) '.mat']; 
    S=load(filename);
    theta_true=S.theta_true;
    theta_hat=S.theta_hat;
    e_s1t1m=S.e_s1t1m;
    e_s2t1m=S.e_s2t1m;
    e_s1t2m=S.e_s1t2m;
    e_s2t2m=S.e_s2t2m;
    ValphaInverse=S.ValphaInverse;
    x1=S.x1;
    x2=S.x2;
    wageT1=S.wageT1;
    wageT2=S.wageT2;
    Sector1chosen_T1=S.Sector1chosen_T1;
    Sector1chosen_T2=S.Sector1chosen_T2;
    theta_start=S.theta_start;
    Rrep=S.Rrep;
    rho=S.rho;
    bhats(irep,:)=theta_hat';
    n=size(x1,1);
  
%     diary on
%     fprintf('\nStructural estimator:        ');
%     fprintf(' %6.3f ',bhats(irep,:));
%     fprintf('\n');
%     diary off
    
    d1=eye(k);
    d2=zeros((k*(k-1)),k);
    ij=1;
    for i=1:(k-1);
        for j=(i+1):k;
            d2(ij,i)=1;
            d2(ij,j)=1;
            ij=ij+1;
            d2(ij,i)=1;
            d2(ij,j)=-1;
            ij=ij+1;
        end;
    end;
    d2=d2';
    d1d2=[d1 d2];

    nboot=1000;
    b_univariate=zeros(nboot,k);
    b_directional=zeros(nboot,(k*(k-1)));
    
    a_s=zeros(nboot*k*k,1);
    delta_s=zeros(nboot*k*k,k);
    boot_id=zeros(nboot*k*k,1);
 
    
    for iboot=1:nboot
    
        
        fprintf('\n')
        fprintf('\n*************************************************\n')
        fprintf('\n     Replication Number: %d',irep)
        fprintf('\n     Bootstrap Number:   %d\n',iboot)
        fprintf('\n*************************************************\n')
        

    
        % Draw a bootstrap sample

        ii=ceil(n*rand(n,1));
        x1b=x1(ii,:);
        x2b=x2(ii,:);
        e11b=randn(n*Rrep,1);
        e21b=randn(n*Rrep,1);
        e12b=randn(n*Rrep,1);
        e22b=randn(n*Rrep,1);
        wageT1b=wageT1(ii);
        wageT2b=wageT2(ii);
        Sector1chosen_T1b=Sector1chosen_T1(ii);
        Sector1chosen_T2b=Sector1chosen_T2(ii);


        % Calculate univarate estimators

        ahats=estimate_a(x1b,x2b,wageT1b,wageT2b,Sector1chosen_T1b,Sector1chosen_T2b,theta_hat,Rrep,rho,d1,e11b,e21b,e12b,e22b);
        b_univariate(iboot,:)=ahats';
        ahats=estimate_a(x1b,x2b,wageT1b,wageT2b,Sector1chosen_T1b,Sector1chosen_T2b,theta_hat,Rrep,rho,d2,e11b,e21b,e12b,e22b);
        b_directional(iboot,:)=ahats';
        a_s((iboot-1)*k*k+1:(iboot-1)*k*k+k*k)= [b_univariate(iboot,:)  b_directional(iboot,:)]';
        delta_s((iboot-1)*k*k+1:(iboot-1)*k*k+k*k,:)= [d1'; d2'];
        boot_id((iboot-1)*k*k+1:(iboot-1)*k*k+k*k)=zeros(k*k,1)+iboot;
   
    end
	
	filename=[lbl1 '_deltas_and_as_fixed_directions' num2str(irep) '.mat']; 
	save(filename, 'theta_hat', 'a_s', 'delta_s', 'boot_id');
%     Results(irep).theta_hat=theta_hat;
%     Results(irep).a_s = a_s;
%     Results(irep).delta_s = delta_s;
%     Results(irep).boot_id = boot_id
%     
%     Vth=OLS_H_V(boot_id,delta_s,a_s);
%     shats1(irep,:)=sqrt(diag(Vth)');
% 	
%     D2=[d1 d2];
%     OMEGA1=cov(b_univariate);
%     OMEGA2=cov([b_univariate b_directional]);
%     
%    
%     
%     
%     [Vcf, Hcf, V, H, fct]=solve_for_V_and_H_Version3(OMEGA1, OMEGA2, D2,should_print) ;
%     fcts(irep,1)=fct;
% %     diary on;
% %     fprintf('\nFunction Value: %8.3f\n',fct);
% %     diary off;
% 
%     Vhat_Alternative=H^(-1)*V*H^(-1);
%     Vhat_Alternative_cf=Hcf^(-1)*Vcf*Hcf^(-1);
%     
%     shats2(irep,:)=sqrt(diag(Vhat_Alternative)');
%     shats3(irep,:)=sqrt(diag(Vhat_Alternative_cf)');
  
    
%     diary on
%     fprintf('\n');
%     fprintf('Structural Parameter Estimates:        ');
%     fprintf(' %6.3f ',bhats(irep,:));
%     fprintf('\n');
%     fprintf('Minimized function value: ');
%     fprintf(' %8.4f ',fct);
%     fprintf('\n');
% 
%     botim=toc;
%     fprintf('\nReplication took: ');
%     sec2hms(botim);
%     fprintf('\n');
% 
%     diary off
    
%     b_true=theta_true;
%     filename=[lbl1 '_fixed_directions_results_temp.mat']; 
%     save(filename, 'b_true', 'bhats', 'shats1', 'shats2','shats3','irep');


end



% b_true=theta_true;
% tstats1=(bhats-repmat(b_true',nrep,1))./shats1;
% tstats2=(bhats-repmat(b_true',nrep,1))./shats2;
% tstats3=(bhats-repmat(b_true',nrep,1))./shats3;
% 
% b_true=theta_true;
%filename=[lbl1 '_fixed_directions_results.mat']; 
%save(filename,'b_true', 'bhats', 'shats1', 'shats2', 'shats3', 'tstats1','tstats2', 'tstats3','fcts','Results');



