function [thetahat,fct,e11m,e21m,e12m,e22m,Valpha_inv]=estimate_theta1a(x1,x2,w1,w2,d1,d2,theta_start,Rrep,rho,e11m,e21m,e12m,e22m)
% notation is sector, t

    n=size(x1,1);
    [alpha,Valpha]=estimate_alpha(x1,x2,w1,w2,d1,d2);
    Valpha_inv=n*(1+1/Rrep)*inv(Valpha);

    if nargin < 12
        stop
        e11m=randn(n,Rrep);
        e21m=randn(n,Rrep);
        e12m=randn(n,Rrep);
        e22m=randn(n,Rrep);
    end
    x1R=repmat(x1,Rrep,1);
    x2R=repmat(x2,Rrep,1);
    e11=reshape(e11m,n*Rrep,1);
    e21=reshape(e21m,n*Rrep,1); 
    e12=reshape(e12m,n*Rrep,1);
    e22=reshape(e22m,n*Rrep,1);
    
    
    k=length(theta_start);
    d1=eye(k);
    d2=zeros((k*(k-1)),k);
    ij=1;
    for i=1:(k-1);
        for j=(i+1):k;
            d2(ij,i)=1;
            d2(ij,j)=1;
            ij=ij+1;
            d2(ij,i)=1;
            d2(ij,j)=-1;
            ij=ij+1;
        end;
    end;
    d2=d2';
    d1a=[d1 d2];
    
    d1=eye(k);
    d2=zeros((k*(k-1)),k);
    ij=1;
    for i=1:(k-1);
        for j=(i+1):k;
            d2(ij,i)=1;
            d2(ij,j)=0.5;
            ij=ij+1;
            d2(ij,i)=1;
            d2(ij,j)=-0.5;
            ij=ij+1;
        end;
    end;
    d2=d2';
    d1b=[d1 d2];
    
    d1=eye(k);
    d2=zeros((k*(k-1)),k);
    ij=1;
    for i=1:(k-1);
        for j=(i+1):k;
            d2(ij,i)=0.5;
            d2(ij,j)=1;
            ij=ij+1;
            d2(ij,i)=0.5;
            d2(ij,j)=-1;
            ij=ij+1;
        end;
    end;
    d2=d2';
    d1c=[d1 d2];
    
    kk=size(d1a,2);
    
    theta=theta_start;
    
    
    [fct1,a,R]=Indirect_fct(x1R,x2R,e11,e21,e12,e22,theta,alpha,Valpha_inv,rho); 
        
    fct1
    
   
    
    not_converged=true;
    

    niter=0;
    whichone=1;
    while not_converged;
    
        niter=niter+1;
        fval=fct1;
        
        if (niter==1)
            np=800;
            dth=0.5;
        else
            np=300;
            dth=0.02;
        end
        
        fprintf('bo_pso \n\n');
        theta
        
        fh = @(th) Indirect_fct(x1R,x2R,e11,e21,e12,e22,th,alpha,Valpha_inv,rho);
        options=optimoptions('particleswarm','SwarmSize',500,'Display','iter','InitialSwarm',theta','MaxTime',12*60*60,'UseParallel',false);
        [theta_ps,fval_ps]=particleswarm(fh,length(theta),(theta-dth)',(theta+dth)',options);
        if (fval_ps<fval)
            fval=fval_ps;
            theta=reshape(theta_ps,length(theta_ps),1);
        end
        fval
        
        fct1=fval;
        
        fprintf('fminsearch \n\n');
        opti=optimset('Display','iter','MaxFunEvals',10000,'MaxIter',1000,'TolFun',1.0e-10,'TolX',1.0e-8);
        [theta, fval]=fminsearch(@(th) Indirect_fct(x1R,x2R,e11,e21,e12,e22,th,alpha,Valpha_inv,rho),theta, opti);
        fval
        
        [theta,fval]=powell(@(th) Indirect_fct(x1R,x2R,e11,e21,e12,e22,th,alpha,Valpha_inv,rho),theta,200,0.00001);
        

        fprintf('linmin \n\n');
        theta1=theta;
        for i=1:kk;
            if (whichone==1)
                 direc=d1a(:,i);
            elseif (whichone==2)
                 direc=d1b(:,i);
            else
                 direc=d1c(:,i);
            end
            direc=(1/sqrt(direc'*direc))*direc;              
            [ath, fval]=linmin(@(ath) Indirect_fct(x1R,x2R,e11,e21,e12,e22,theta+ath*direc,alpha,Valpha_inv,rho),0, 0.5,0.0001,200);
            theta=theta+ath*direc;
            
            [i k fval]
        end
        direc=theta-theta1;
        if (sqrt(direc'*direc)>0.0001)
            direc=(1/sqrt(direc'*direc))*direc; 
            [ath, fval]=linmin(@(ath) Indirect_fct(x1R,x2R,e11,e21,e12,e22,theta+ath*direc,alpha,Valpha_inv,rho),0, 0.5,0.0001,200);
            theta=theta+ath*direc;
            [-99 fval]
        end;
        
        whichone=mod(whichone,3)+1;
        

    
        not_converged=(abs(fct1-fval)>0.0001);
        fct1=fval;
    end
    
    
    
    thetahat=theta;
    [fct,a,R]=Indirect_fct(x1R,x2R,e11,e21,e12,e22,thetahat,alpha,Valpha_inv,rho); 
     
end