%  MONTE CARLO incl regular BS
clear;

lbl1='MC_2-trade'; 
nrep=400;


np=1;
ii=1;
% mytask=getenv('SLURM_ARRAY_TASK_ID');
% ii=str2num(mytask);

% nrep1=1+np*(ii-1);
% nrep2=np*ii;
 
nrep1=1;
nrep2=nrep;


logfile_name=strcat(lbl1,'-Diary', num2str(ii,'%03i'), '.log');
filenameout=[lbl1 '_' num2str(ii,'%03i') '.mat']; 
delete(logfile_name);
diary(logfile_name);
diary on
load datatrade_continents.mat;

year=x(:,4);
y=(x(:,5) > 0);
M=x(:,5);

distance=x(:,19);
border=x(:,20);
island=x(:,25);
landlocked=x(:,26);
legal=x(:,22);
language=x(:,21);
colonial=x(:,24);
cu=x(:,6);
fta=x(:,7);
religion=x(:,23);
wto_non=x(:,9);
wto_both=x(:,8);


idi=x(:,1);
idj=x(:,2);
yeardummy=x(:,10:18);
n=size(x,1);

nc=max(idi);
ii=repmat(1:nc,n,1);
jj=repmat(idi,1,nc);
exportdummy=(jj == ii);
exportdummy=exportdummy(:,1:nc-1);
nc=max(idj);
jj=repmat(idj,1,nc);
importdummy=(jj == ii);
importdummy=importdummy(:,1:nc-1);

x=[distance border island landlocked legal language colonial cu fta wto_non wto_both religion];
explvar={'distance' 'border' 'island' 'landlocked' 'legal' 'language' 'colonial' 'cu' 'fta' 'wto_non' 'wto_both' 'religion'};
[n, k]=size(x);

xx1data=[x ones(n,1) importdummy exportdummy];
xx1data_with_year=[xx1data year];

tic
[bhat,scores,hess,Failed]=probit(y,xx1data);
if (Failed==1)
    fprintf('\n    failed 1')
    stop
end
V11=scores'*scores/n;
Q1=hess/n;
mef=normpdf(mean(xx1data*bhat))*bhat;
fprintf('\n\n');
fprintf('%20s  %8s  %8s\n', 'variable','coef','mef')
for i=1:k
     fprintf('%20s  %8.3f  %8.3f\n',explvar{i},bhat(i), mef(i))
end
fprintf('\n\n');
toc
tic
z=xx1data*bhat;
mill=millsratio(z);



x=[exp(distance) border island landlocked legal language colonial cu fta wto_non wto_both];
explvar={'distance' 'border' 'island' 'landlocked' 'legal' 'language' 'colonial' 'cu' 'fta' 'wto_non' 'wto_both' 'mill' 'delta'};

xx2data=[x yeardummy importdummy exportdummy];
xx2data_with_year=[xx2data year];

[thhat,si2,df,edf]=estimate_Power(xx2data,mill,M);

fprintf('\n\n');
fprintf('%20s  %8s\n', 'variable','coef')
for i=1:size(x,2)
     fprintf('%20s  %8.3f\n',explvar{i},thhat(i))
end

fprintf('%20s  %8.3f\n',explvar{length(explvar)-1},thhat(length(thhat)-1))
fprintf('%20s  %8.3f\n',explvar{length(explvar)},(thhat(length(thhat))))
fprintf('\n\n');
fprintf('%20s  %8.3f\n','var',si2)
fprintf('\n\n');
toc




% MONTE CARLO SIMULATION

k1=length(bhat);
k2=length(thhat);
k=k2-2;

thif_MC=zeros(nrep,k2);
th_MC=zeros(nrep,k2);
sNLS_MC=zeros(nrep,k2);
sNLSif_MC=zeros(nrep,k2);
s_MC=zeros(nrep,k2);
s_MC_regular=zeros(nrep,k2);


for irep=nrep1:nrep2
    
    fprintf('\nREPLICATION NUMBER %5i    Time:  ',irep);
    c = clock;
    disp(datestr(datenum(c(1),c(2),c(3),c(4),c(5),c(6))));
    fprintf('\n');
    % Generate data

    rng(7509+31*irep,'twister');
    Failed=1;
    
    while (Failed==1)
        v=randn(n,1);
        rho=0.5;
        epsi=rho*v+randn(n,1)*sqrt(1-rho^2);
        xb_eq1=xx1data*bhat;
        d=(xb_eq1+v>0);
        si=3;

        y=func(xx2data(:,1),xx2data(:,2:k),thhat(1:k),thhat(k+2));
        y=y+si*epsi;
        y=exp(y).*d;

        % Data generated

    %     infeasible
        z=xx1data*bhat;
        mill=millsratio(z);
        [th_nls,si2,df,edf]=estimate_Power(xx2data,mill,y);
        thif_MC(irep,:)=th_nls';
        R2=df'*df/n;
        V22=edf'*edf/n;
        sNLSif_MC(irep,:)=sqrt(diag(inv(R2)'*V22*inv(R2))')/sqrt(n);


    %     
        i80=find(year==1980);
        xx1data80=xx1data(i80,:);
        d80=d(i80);
        [bhat_probit,scores,hess, Failed]=probit(d80,xx1data80);
        if (Failed==1)
            fprintf('\nfailed 2')
        end
    end
    V11=scores'*scores/n;
    Q1=hess/n;
    z=xx1data*bhat_probit;
    mill=millsratio(z);
    [th_nls,si2,df,edf]=estimate_Power(xx2data,mill,y);
    R2=df'*df/n;
    V22=edf'*edf/n;
    score2=edf;
    th_MC(irep,:)=th_nls';
    sNLS_MC(irep,:)=sqrt(diag(inv(R2)'*V22*inv(R2))')/sqrt(n);

    nboot=1000;
    yy=d;
    MM=y;

    bh=zeros(nboot,k1);
    th1=zeros(nboot,k2);
    th2=zeros(nboot,k2);
    th_boot_regular=zeros(nboot,k2);
    for ib=1:nboot
        fprintf('\nBootstrap number: %5i',ib);
        Failed=1;
        while (Failed==1)
            ii=ceil(n*rand(n,1));
            xx1=xx1data(ii,:);
            y=yy(ii);
            xx2=xx2data(ii,:);
            M=MM(ii);
            i80=find(year(ii)==1980);
            xx1data80=xx1(i80,:);
            d80=y(i80);
            [bhat_bs,scores,hess,Failed]=probit(d80,xx1data80,bhat_probit);
            if (Failed==1)
                fprintf('\n   Probit Failed in BS --- try again')
            end
        end
        bh(ib,:)=bhat_bs';
        z1=xx1*bhat_bs;
        z2=xx1*bhat_probit;

        mill=millsratio(z1);
        
        [th_bs,si2,df,edf]=estimate_Power(xx2,mill,M);
        th_boot_regular(ib,:)=th_bs';
        
        [th1bs, th2bs]=estimate_Power_hold_fixed(xx2,mill,M,th_nls);
        thhat_bs1=[th1bs;th2bs];
        th1(ib,:)=thhat_bs1';

        mill=millsratio(z2);
        [th1bs, th2bs]=estimate_Power_hold_fixed(xx2,mill,M,th_nls);
        thhat_bs2=[th1bs;th2bs];
        th2(ib,:)=thhat_bs2';


        
    end

    OMEGA=n*cov([bh th1 th2]);

    OMEGA12=OMEGA(1:k1,k1+1:k1+k2);
    OMEGA13=OMEGA(1:k1,k1+1+k2:k1+k2+k2);
    VV12=zeros(k1,k2);
    RR12=zeros(k1,k2);

    o12=OMEGA12(:,1:k2-1);
    o13=OMEGA13(:,1:k2-1);
    VV12(:,1:k2-1)=Q1*o13*R2(1:k2-1,1:k2-1);
    RR12(:,1:k2-1)=Q1*inv(V11)*Q1*(o13-o12)*R2(1:k2-1,1:k2-1);


    o12=OMEGA12(:,k2);
    o13=OMEGA13(:,k2);
    VV12(:,k2)=R2(k2,k2)*Q1*o13;
    RR12(:,k2)=R2(k2,k2)*Q1*inv(V11)*Q1*(o13-o12);

    V12=VV12;
    R1=RR12';

    A=[Q1 zeros(k1,k2); R1 R2];
    B=[V11 V12; V12' V22];
    A=inv(A);
    C=A*B*A';
    ss=sqrt(diag(C)')/sqrt(n);
    s_MC(irep,:)=ss(k1+1:k1+k2);
    s_MC_regular(irep,:)=sqrt(diag(cov(th_boot_regular)));

	save(filenameout, 'th_MC','thhat','s_MC', 's_MC_regular', 'sNLS_MC', 'sNLSif_MC', 'thif_MC');


end






    
